
#ifdef __cplusplus
extern "C" {
#endif

#pragma once


#include "HROOT-histType.h"

#include "HROOTHistTH1.h"

#include "HROOTCoreTArrayF.h"

#include "HROOTCoreTNamed.h"

#include "HROOTCoreTAttLine.h"

#include "HROOTCoreTAttFill.h"

#include "HROOTCoreTAttMarker.h"

#include "HROOTCoreTObject.h"

#include "STDDeletable.h"

#include "HROOTCoreTArray.h"

#include "HROOT-coreType.h"


#define TH1F_DECL_VIRT(Type) \



#define TH1F_DECL_NONVIRT(Type) \
Type##_p Type##_newTH1F ( const char* name, const char* title, int nbinsx, double xlow, double xup );


#define TH1F_DECL_ACCESSOR(Type) \



#define TH1F_DEF_VIRT(Type) \



#define TH1F_DEF_NONVIRT(Type) \
Type##_p Type##_newTH1F ( const char* name, const char* title, int nbinsx, double xlow, double xup ) {\
Type* newp=new Type(name, title, nbinsx, xlow, xup);return from_nonconst_to_nonconst<Type##_t, Type>(newp);\
}


#define TH1F_DEF_ACCESSOR(Type) \



TH1_DECL_VIRT(TH1F)
TARRAYF_DECL_VIRT(TH1F)
TNAMED_DECL_VIRT(TH1F)
TATTLINE_DECL_VIRT(TH1F)
TATTFILL_DECL_VIRT(TH1F)
TATTMARKER_DECL_VIRT(TH1F)
TOBJECT_DECL_VIRT(TH1F)
DELETABLE_DECL_VIRT(TH1F)
TARRAY_DECL_VIRT(TH1F)
TH1F_DECL_VIRT(TH1F)
TH1F_DECL_NONVIRT(TH1F)
TH1F_DECL_ACCESSOR(TH1F)

#ifdef __cplusplus
}
#endif

