
#include "MacroPatternMatch.h"

#include "HROOTHistTH1D.h"

#include "HROOTHistTH1.h"

#include "HROOTHistTF1.h"

#include "HROOTCoreTAtt3D.h"

#include "TH3.h"

#include "HROOTHistTH3.h"

using namespace ROOT;

#define CHECKPROTECT(x,y) FXIS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  FXIIF( CHECKPROTECT(cname,mname) ) ( \
  (from_nonconst_to_nonconst<oname,cname ## _t>), \
  (from_nonconst_to_nonconst<cname,cname ## _t>) )


#define IS_TH3_fill1_PROTECTED ()

#define IS_TH3_fill1w_PROTECTED ()
TH1_DEF_VIRT(TH3)
TATT3D_DEF_VIRT(TH3)
TNAMED_DEF_VIRT(TH3)
TATTLINE_DEF_VIRT(TH3)
TATTFILL_DEF_VIRT(TH3)
TATTMARKER_DEF_VIRT(TH3)
TOBJECT_DEF_VIRT(TH3)
DELETABLE_DEF_VIRT(TH3)
TH3_DEF_VIRT(TH3)
TH3_DEF_NONVIRT(TH3)
TH3_DEF_ACCESSOR(TH3)

